[Solved]Openssh-server fails to restart during update

Kernels & Hardware, configuring network, installing services

[Solved]Openssh-server fails to restart during update

Postby Grimnar » 2010-02-12 20:00

So this very (for me) important little package fails me once again. But this time it refuses to restart/start

This is the output:

Code: Select all
Setting up openssh-server (1:5.3p1:-1)
Restarting OpenBSD Secure Shell Server: sshd: failed!
/dev/null is not a character device!
invoke-rc.d: initscript ssh, action "restart" failed.
dpkg: error processing openssh-server (--configure)
 subprocess installed post-installation script returned error exit status 1
Errors were encountered while processing:
openssh-server


dpkg -purge openssh-server: failed, same thing
aptitude: same thing.

So, now what? :o

The error is within the /etc/init.d/ssh script. ("error")
This is in squeeze so I can only blame my self, but.. This is one of the packages that fair and square should not fail to install/update/start/restart no mather what! :evil:

Had this problem for a week now, and wanted to cool it with this forum to see if an update was posted or someone else had the same problems. Even checked with google. Nothing after 2007 and then the version is not the same and all.

-Andreas
Last edited by Grimnar on 2010-02-13 12:54, edited 1 time in total.
User avatar
Grimnar
 
Posts: 173
Joined: 2008-03-30 16:24

Re: Openssh-server fails to restart during update

Postby smallchange » 2010-02-12 20:06

So the ssh server is not running at the moment? /etc/init.d/ssh start fails? What message do you get? You seem to imply that you have had trouble with the ssh server before. Did you customize it at that time?
smallchange
 
Posts: 1740
Joined: 2009-05-04 15:56

Re: Openssh-server fails to restart during update

Postby Grimnar » 2010-02-12 20:29

smallchange wrote:So the ssh server is not running at the moment? /etc/init.d/ssh start fails? What message do you get? You seem to imply that you have had trouble with the ssh server before. Did you customize it at that time?


Same error (/dev/null is not a character device!)
No custom stuff on this install.
User avatar
Grimnar
 
Posts: 173
Joined: 2008-03-30 16:24

Re: Openssh-server fails to restart during update

Postby smallchange » 2010-02-12 21:31

How did you /dev/null get to not be a character device?
Code: Select all
ls -l /dev/null
crw-rw-rw- 1 root root 1, 3 2010-01-14 16:27 /dev/null
I assume that the error is generated when you run "/etc/init.d/ssh start"? That script is almost certainly redirected to /dev/null.
smallchange
 
Posts: 1740
Joined: 2009-05-04 15:56

Re: Openssh-server fails to restart during update

Postby Grimnar » 2010-02-12 21:36

smallchange wrote:How did you /dev/null get to not be a character device?
Code: Select all
ls -l /dev/null
crw-rw-rw- 1 root root 1, 3 2010-01-14 16:27 /dev/null
I assume that the error is generated when you run "/etc/init.d/ssh start"? That script is almost certainly redirected to /dev/null.


Yeah, its a line in the /etc/init.d/ssh script. Im sorry, Im not at the computer right now so I cant paste correct line.
User avatar
Grimnar
 
Posts: 173
Joined: 2008-03-30 16:24

Re: Openssh-server fails to restart during update

Postby Grimnar » 2010-02-12 21:48

/etc/init.d/ssh
log_action_msg "/dev/null is not a character device!"
Code: Select all
#! /bin/sh

### BEGIN INIT INFO
# Provides:      sshd
# Required-Start:   $remote_fs $syslog
# Required-Stop:   $remote_fs $syslog
# Default-Start:   2 3 4 5
# Default-Stop:      
# Short-Description:   OpenBSD Secure Shell server
### END INIT INFO

set -e

# /etc/init.d/ssh: start and stop the OpenBSD "secure shell(tm)" daemon

test -x /usr/sbin/sshd || exit 0
( /usr/sbin/sshd -\? 2>&1 | grep -q OpenSSH ) 2>/dev/null || exit 0

umask 022

export SSHD_OOM_ADJUST=-17
if test -f /etc/default/ssh; then
    . /etc/default/ssh
fi

# Are we in a virtual environment that doesn't support modifying
# /proc/self/oom_adj?
if grep -q 'envID:.*[1-9]' /proc/self/status; then
    unset SSHD_OOM_ADJUST
fi

. /lib/lsb/init-functions

if [ -n "$2" ]; then
    SSHD_OPTS="$SSHD_OPTS $2"
fi

# Are we running from init?
run_by_init() {
    ([ "$previous" ] && [ "$runlevel" ]) || [ "$runlevel" = S ]
}

check_for_no_start() {
    # forget it if we're trying to start, and /etc/ssh/sshd_not_to_be_run exists
    if [ -e /etc/ssh/sshd_not_to_be_run ]; then
   if [ "$1" = log_end_msg ]; then
       log_end_msg 0
   fi
   if ! run_by_init; then
       log_action_msg "OpenBSD Secure Shell server not in use (/etc/ssh/sshd_not_to_be_run)"
   fi
   exit 0
    fi
}

check_dev_null() {
    if [ ! -c /dev/null ]; then
   if [ "$1" = log_end_msg ]; then
       log_end_msg 1 || true
   fi
   if ! run_by_init; then
       log_action_msg "/dev/null is not a character device!"
   fi
   exit 1
    fi
}

check_privsep_dir() {
    # Create the PrivSep empty dir if necessary
    if [ ! -d /var/run/sshd ]; then
   mkdir /var/run/sshd
   chmod 0755 /var/run/sshd
    fi
}

check_config() {
    if [ ! -e /etc/ssh/sshd_not_to_be_run ]; then
   /usr/sbin/sshd $SSHD_OPTS -t || exit 1
    fi
}

export PATH="${PATH:+$PATH:}/usr/sbin:/sbin"

case "$1" in
  start)
   check_privsep_dir
   check_for_no_start
   check_dev_null
   log_daemon_msg "Starting OpenBSD Secure Shell server" "sshd"
   if start-stop-daemon --start --quiet --oknodo --pidfile /var/run/sshd.pid --exec /usr/sbin/sshd -- $SSHD_OPTS; then
       log_end_msg 0
   else
       log_end_msg 1
   fi
   ;;
  stop)
   log_daemon_msg "Stopping OpenBSD Secure Shell server" "sshd"
   if start-stop-daemon --stop --quiet --oknodo --pidfile /var/run/sshd.pid; then
       log_end_msg 0
   else
       log_end_msg 1
   fi
   ;;

  reload|force-reload)
   check_for_no_start
   check_config
   log_daemon_msg "Reloading OpenBSD Secure Shell server's configuration" "sshd"
   if start-stop-daemon --stop --signal 1 --quiet --oknodo --pidfile /var/run/sshd.pid --exec /usr/sbin/sshd; then
       log_end_msg 0
   else
       log_end_msg 1
   fi
   ;;

  restart)
   check_privsep_dir
   check_config
   log_daemon_msg "Restarting OpenBSD Secure Shell server" "sshd"
   start-stop-daemon --stop --quiet --oknodo --retry 30 --pidfile /var/run/sshd.pid
   check_for_no_start log_end_msg
   check_dev_null log_end_msg
   if start-stop-daemon --start --quiet --oknodo --pidfile /var/run/sshd.pid --exec /usr/sbin/sshd -- $SSHD_OPTS; then
       log_end_msg 0
   else
       log_end_msg 1
   fi
   ;;

  try-restart)
   check_privsep_dir
   check_config
   log_daemon_msg "Restarting OpenBSD Secure Shell server" "sshd"
   set +e
   start-stop-daemon --stop --quiet --retry 30 --pidfile /var/run/sshd.pid
   RET="$?"
   set -e
   case $RET in
       0)
      # old daemon stopped
      check_for_no_start log_end_msg
      check_dev_null log_end_msg
      if start-stop-daemon --start --quiet --oknodo --pidfile /var/run/sshd.pid --exec /usr/sbin/sshd -- $SSHD_OPTS; then
          log_end_msg 0
      else
          log_end_msg 1
      fi
      ;;
       1)
      # daemon not running
      log_progress_msg "(not running)"
      log_end_msg 0
      ;;
       *)
      # failed to stop
      log_progress_msg "(failed to stop)"
      log_end_msg 1
      ;;
   esac
   ;;

  status)
   status_of_proc -p /var/run/sshd.pid /usr/sbin/sshd sshd && exit 0 || exit $?
   ;;

  *)
   log_action_msg "Usage: /etc/init.d/ssh {start|stop|reload|force-reload|restart|try-restart|status}"
   exit 1
esac

exit 0


/dev/null :)

Code: Select all
-rw-rw-rw- 1 root root 0 2010-02-12 22:40 /dev/null
User avatar
Grimnar
 
Posts: 173
Joined: 2008-03-30 16:24

Re: Openssh-server fails to restart during update

Postby smallchange » 2010-02-12 22:11

Notice that /dev/null does not have the C at the beginning so it is in fact not a character device. Are you running Lenny or Squeeze or Sid? That device file should be generated at boot by udev, at least on testing/unstable. I am not sure about Lenny and if you are running Etch there is a good change it is done by devfs or MKDEV.
smallchange
 
Posts: 1740
Joined: 2009-05-04 15:56

Re: Openssh-server fails to restart during update

Postby Grimnar » 2010-02-12 22:16

smallchange wrote:Notice that /dev/null does not have the C at the beginning so it is in fact not a character device. Are you running Lenny or Squeeze or Sid? That device file should be generated at boot by udev, at least on testing/unstable. I am not sure about Lenny and if you are running Etch there is a good change it is done by devfs or MKDEV.


I'm running squeeze and I'm going to reboot in about 45 minutes due to ram upgrade. Maybe it will fix it self then?
User avatar
Grimnar
 
Posts: 173
Joined: 2008-03-30 16:24

Re: Openssh-server fails to restart during update

Postby smallchange » 2010-02-12 22:20

It sure should, but I am not sure how it got this way in the first place so it is hard to say.
smallchange
 
Posts: 1740
Joined: 2009-05-04 15:56

Re: Openssh-server fails to restart during update

Postby Grimnar » 2010-02-13 00:54

Up and running with 3gb ram :D

And yeah, sshd is now up to date as well! :D
User avatar
Grimnar
 
Posts: 173
Joined: 2008-03-30 16:24


Return to System configuration

Who is online

Users browsing this forum: No registered users and 13 guests

fashionable